Đến nội dung


Hình ảnh
- - - - -

[Nhờ Viết Lisp] Chuyển Đường Cong Tròn, Spline Thành Pline Gồm Nhiều Đoạn Thẳng Nhỏ Nối Lại


  • Please log in to reply
5 replies to this topic

#1 Thanh BMT

Thanh BMT

    biết zoom

  • Members
  • Pip
  • 15 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 17 May 2016 - 10:40 AM

Không biết có cao thủ nào giải đáp được yêu cầu của em ko? Tình hình là em muốn nhờ viết hộ lisp chuyển (hoặc vẽ thêm) đường Pline bám sát đường cong (cong tròn, elip, spline ...) gồm nhiều đoạn THẲNG nhỏ nối lại (tạo thành từng đốt), có tuỳ chọn chiều dài đốt trong pline mới tạo. Xin cảm ơn!


  • -1

#2 phongtran86

phongtran86

    biết lệnh offset

  • Members
  • PipPipPip
  • 177 Bài viết
Điểm đánh giá: 22 (tàm tạm)

Đã gửi 17 May 2016 - 12:49 PM

Lisp này để tạo đối tượng wipeout trong bản vẽ? Theo mình nhớ diễn đàn có lisp này rồi
  • 0

#3 Thanh BMT

Thanh BMT

    biết zoom

  • Members
  • Pip
  • 15 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 17 May 2016 - 04:13 PM

Lisp này để tạo đối tượng wipeout trong bản vẽ? Theo mình nhớ diễn đàn có lisp này rồi

Khi thiết kế đường mặt bằng giao thông, nhiều lúc muốn bo cong để vuốt nối các mép cho khỏi gãy khúc. Sau đấy mình dùng một số lệnh trong ADS để hoàn thiện mặt bằng (vẽ taluy chẳng hạn), nhưng thằng ADS chỉ nhận Pline là những đoạn thẳng nhỏ nối liền chứ không nhận cung cong. Vầy mới khổ chứ!

Bạn bảo có lisp này trên diễn đàn, sao mình tìm mãi không thấy nhỉ?


  • 0

#4 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5454 Bài viết
Điểm đánh giá: 2626 (tuyệt vời)

Đã gửi 17 May 2016 - 04:18 PM

Cho bạn 1 cái tạm nè! Lệnh: HA

(defun HA:ListPoints1 (ent len / x lenc lst)
 (setq x 0 lenc (vlax-curve-getdistatparam ent (vlax-curve-getendparam ent)) lst (cons (vlax-curve-getpointatdist ent x) lst))
 (while (< (setq x (+ x len)) lenc)
  (setq lst (cons (vlax-curve-getpointatdist ent x) lst)))
 (reverse (setq lst (cons (vlax-curve-getEndpoint ent) lst))))
(defun LWPoly (lst cls)
 (entmake (append (list (cons 0 "LWPOLYLINE") (cons 100 "AcDbEntity") (cons 100 "AcDbPolyline")
   (cons 90 (length lst)) (cons 70 cls)) (mapcar (function (lambda (p) (cons 10 p))) lst))))
;-----(vlax-curve-isclosed ent)
(defun C:HA()
 (setq ent (car (entsel "\nChon Curve de Convert: ")))
 (setq lst (HA:ListPoints1 ent 100))
 (LWPoly lst 0)
 (princ))

  • 1

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.


#5 Thanh BMT

Thanh BMT

    biết zoom

  • Members
  • Pip
  • 15 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 17 May 2016 - 05:00 PM

 

Cho bạn 1 cái tạm nè!


Mình thử lisp của bạn nhưng gặp lỗi, lúc hiện lên dòng "Chon Curve de Convert:", mình kick chọn đối tượng thì hiện lỗi "error: bad DXF group: nil"

Mình thử ngay bản cad mới mở cũng bị như vậy bạn ạ.


  • 0

#6 Doan Van Ha

Doan Van Ha

    biết lệnh adcenter

  • CADViet Team
  • PipPipPipPipPipPipPip
  • 5454 Bài viết
Điểm đánh giá: 2626 (tuyệt vời)

Đã gửi 17 May 2016 - 05:03 PM

Đưa bản vẽ lên xem sao


  • 0

* Chỉ nên yêu cầu Lisp khi bạn làm việc đó mất cả ngày nhưng họ chỉ viết 1 giờ. Đừng nêu yêu cầu Lisp khi bạn chỉ làm 1 giờ nhưng bắt họ phải mất cả ngày.

* Nhờ viết lisp cũng như đi khám bệnh. Chỉ gởi căn cước và than sắp chết thì không bác sỹ nào cứu sống được.